PROGRAM TEST ([0x0100..0x1fff] [0x2000..0x2fff] [0x20..0xbf]);

VAR IB1: BYTE;
VAR IB2: BYTE;
VAR IB3: BYTE;
VAR IB4: [ib4_7 ib4_6 ib4_5 ib4_4 ib4_3 ib4_2 ib4_1 ib4_0];

VAR IW1: WORD;
VAR IW2: WORD;
VAR IW3: WORD;
VAR IW4: WORD;

VAR IAB: ARRAY  8 OF BYTE INTERN;
VAR IAW: ARRAY  6 OF WORD INTERN;
VAR UAB: ARRAY 16 OF BYTE;
VAR UAW: ARRAY  8 OF WORD;

VAR XAW: ARRAY  8 OF WORD EXTERN;
VAR XAB: ARRAY 16 OF BYTE EXTERN;
VAR XB1: BYTE EXTERN;
VAR XB2: BYTE EXTERN;
VAR XB3: BYTE EXTERN;
VAR XB4: BYTE EXTERN;
VAR XW1: WORD EXTERN;
VAR XW2: WORD EXTERN;
VAR XW3: WORD EXTERN;
VAR XW4: WORD EXTERN;

VAR DPTR[0x082]: WORD;
VAR PCON[0x087]: [SMOD PDS IDLS SD GF1 GF0 PD IDLE];
VAR PSW [0x0d0]: [Cy AC F0 RS1 RS0 OV * Parity];
VAR ACC [0x0e0]: BYTE;
VAR R0  [0x108]: BYTE;
VAR R1  [0x109]: BYTE;
VAR R7  [0x10f]: BYTE;
VAR R6W [0x10e]: WORD;

PROCEDURE regpara (x [$10F]: BYTE);
.assert 8f 20 22
BEGIN
    IB1 := x;
END;


PROCEDURE AssertRegpara;
BEGIN
.assert 7f 02 31 00
   regpara (2);
.assert af 21 31 00 22
   regpara (IB2);
END;


PROCEDURE AssertTable;
.assert 34 12 21 43 78 56 65 87
TABLE T1: ARRAY 4 OF WORD = [0x1234, 0x4321, 0x5678, 0x8765];
.assert 22
END;


PROCEDURE AssertConstByte;
BEGIN
.assert 74 2a 
	ACC		:= 0x2a;
.assert 78 2a 
	R0		:= 0x2a;
.assert 75 20 2a 
	IB1		:= 0x2a;
.assert 75 2d 2a 
	IAB[  1]	:= 0x2a;
.assert e5 20 24 2c f8 76 2a 
	IAB[IB1]	:= 0x2a;
.assert 78 b1 76 2a 
	UAB[  1]	:= 0x2a;
.assert e5 20 24 b0 f8 76 2a 
	UAB[IB1]	:= 0x2a;
.assert 90 20 20 74 2a f0 
	XB1		:= 0x2a;
.assert 90 20 13 74 2a f0 
	XAB[  3]	:= 0x2a;
.assert 22
END;


PROCEDURE AssertConstWord;
BEGIN
.assert 7e 34 7f 12 
	R6W		:= 0x1234;
.assert 75 24 34 75 25 12 
	IW1		:= 0x1234;
.assert 75 36 34 75 37 12 
	IAW[  1]	:= 0x1234;
.assert e5 20 c3 33 24 34 f8 76 34 08 76 12 
	IAW[IB1]	:= 0x1234;
.assert 78 a2 76 34 08 76 12 
	UAW[  1]	:= 0x1234;
.assert e5 20 c3 33 24 a0 f8 76 34 08 76 12 
	UAW[IB1]	:= 0x1234;
.assert 90 20 24 74 34 f0 a3 74 12 f0 
	XW1		:= 0x1234;
.assert 90 20 06 74 34 f0 a3 74 12 f0 
	XAW[  3]	:= 0x1234;
.assert 7e b1 7f 03 
	R6W := 'α';
.assert 7e ac 7f 20 
	R6W := '€';
.assert 22
END;


PROCEDURE AssertBitOps;
BEGIN
.assert	d3 c3 b3
	Set (Cy)      ; Clr (Cy)      ; Cpl (Cy)      ;
.assert d2 d6 c2 d6 b2 d6
	Set (AC)      ; Clr (AC)      ; Cpl (AC)      ;
.assert 43 87 04 53 87 fb 63 87 08
	Set (GF0)     ; Clr (GF0)     ; Cpl (GF1)     ;
.assert d2 19 c2 19 b2 19
	Set (ib4_1)   ; Clr (ib4_1)   ; Cpl (ib4_1)   ;
.assert d2 7e c2 7e b2 7e
	Set (IAB[3],6); Clr (IAB[3],6); Cpl (IAB[3],6);
.assert 43 30 20 53 30 df 63 30 20
	Set (IAB[4],5); Clr (IAB[4],5); Cpl (IAB[4],5);
.assert 78 b5 e6 d2 e4 f6 78 b5 e6 c2 e4 f6 78 b5 e6 b2 e4 f6 
	Set (UAB[5],4); Clr (UAB[5],4); Cpl (UAB[5],4);
.assert 90 20 23 e0 d2 e1 f0 90 20 23 e0 c2 e1 f0 90 20 23 e0 b2 e1 f0 
	Set (XB4,1)   ; Clr (XB4,1)   ; Cpl (XB4, 1)  ;
.assert 22
END;

PROCEDURE AssertIncr;
BEGIN
.assert 04
	INCR (ACC);
.assert 08
	INCR (R0 );
.assert 05 20
	INCR (IB1);
.assert 05 2d
	INCR (IAB[1]);
.assert 78 b1 06
	INCR (UAB[1]);
.assert 90 20 20 e0 04 f0 
	INCR (XB1);

.assert 0e ee 70 01 0f
	INCR (R6W );
.assert 05 24 e5 24 70 02 05 25
	INCR (IW1);
.assert 05 36 e5 36 70 02 05 37 
	INCR (IAW[1]);
.assert 78 a2 06 e6 70 02 08 06 
	INCR (UAW[1]);
.assert 90 20 24 e0 04 f0 70 04 a3 e0 04 f0 
	INCR (XW1);
.assert 22
END;

PROCEDURE AssertDecr;
BEGIN
.assert 14
	DECR (ACC);
.assert 18
	DECR (R0 );
.assert 15 20
	DECR (IB1);
.assert 15 2d
	DECR (IAB[1]);
.assert 78 b1 16
	DECR (UAB[1]);
.assert 90 20 20 e0 14 f0 
	DECR (XB1);

.assert 1e ee b4 ff 01 1f 
	DECR (R6W );
.assert 15 24 e5 24 b4 ff 02 15 25 
	DECR (IW1);
.assert 15 36 e5 36 b4 ff 02 15 37 
	DECR (IAW[1]);
.assert 78 a2 16 e6 b4 ff 02 08 16 
	DECR (UAW[1]);
.assert 90 20 24 e0 14 f0 b4 ff 04 a3 e0 04 f0 
	DECR (XW1);

.assert 22
END;

PROCEDURE AssertShl;
BEGIN
.assert c3 33
	SHL (ACC);
.assert c3 e8 33 f8
	SHL (R0 );
.assert c3 e5 20 33 f5 20
	SHL (IB1);
.assert c3 e5 2d 33 f5 2d
	SHL (IAB[1]);
.assert 78 b1 c3 e6 33 f6
	SHL (UAB[1]);
.assert 90 20 20 c3 e0 33 f0 
	SHL (XB1);
.assert c3 ee 33 fe ef 33 ff 
	SHL (R6W );
.assert c3 e5 24 33 f5 24 e5 25 33 f5 25 
	SHL (IW1);
.assert c3 e5 36 33 f5 36 e5 37 33 f5 37 
	SHL (IAW[1]);
.assert 78 a2 c3 e6 33 f6 08 e6 33 f6
	SHL (UAW[1]);
.assert	90 20 24 c3 e0 33 f0 a3 e0 33 f0 
	SHL (XW1);
.assert 22
END;

PROCEDURE AssertShr;
BEGIN
.assert c3 13 
	SHR (ACC);
.assert c3 e8 13 f8 
	SHR (R0 );
.assert c3 e5 20 13 f5 20 
	SHR (IB1);
.assert c3 e5 2d 13 f5 2d 
	SHR (IAB[1]);
.assert 78 b1 c3 e6 13 f6 
	SHR (UAB[1]);
.assert 90 20 20 c3 e0 13 f0 
	SHR (XB1);
.assert c3 ef 13 ff ee 13 fe 
	SHR (R6W );
.assert c3 e5 25 13 f5 25 e5 24 13 f5 24 
	SHR (IW1);
.assert c3 e5 37 13 f5 37 e5 36 13 f5 36 
	SHR (IAW[1]);
.assert 78 a2 c3 08 e6 13 f6 18 e6 13 f6 
	SHR (UAW[1]);
.assert 90 20 24 c3 a3 e0 13 f0 05 82 d5 82 02 15 83 15 82 e0 13 f0 
	SHR (XW1);
.assert 22
END;

PROCEDURE AssertLoop;
BEGIN
.assert 80 fe 
	LOOP END;

.assert 60 fe 
	REPEAT UNTIL ACC;

.assert 70 fe 
	REPEAT UNTIL NOT ACC;

.assert 50 fe 
	REPEAT UNTIL Cy;

.assert 40 fe 
	REPEAT UNTIL NOT Cy;

.assert 30 d6 fd 
	REPEAT UNTIL AC;

.assert 20 d6 fd 
	REPEAT UNTIL NOT AC;

.assert e5 87 30 e2 fb 
	REPEAT UNTIL GF0;

.assert e5 87 20 e2 fb 
	REPEAT UNTIL NOT GF0;

.assert e5 82 45 83 60 fa 
	REPEAT UNTIL DPTR;

.assert 22
END;


PROCEDURE AssertConstEval;
BEGIN
.assert 75 20 00 
	IB1 := IW1 AND 0x100;

.assert 85 24 20 
	IB1 := IW1 AND 0x0ff;

.assert 85 24 20 
	IB1 := IW1 OR  0x100;

.assert 75 20 ff 
	IB1 := IW1 OR  0x0ff;

.assert 85 24 20 
	IB1 := IW1 XOR 0x100;

.assert e5 24 f4 f5 20 
	IB1 := IW1 XOR 0x0ff;

.assert e5 24 04 f5 20 
	IB1 := IW1 + 1;

.assert e5 24 14 f5 20 
	IB1 := IW1 - 1;

.assert e5 24 f4 f5 20 
	IB1 := 255 - IW1;

.assert e5 24 f4 04 f5 20 
	IB1 := 0 - IW1;

.assert e5 21 55 28 f5 24 75 25 00 
	IW1 := IB2 AND IW3;

.assert e5 21 25 28 f5 20 
	IB1 := IB2  +  IW3;

.assert e5 21 25 28 f5 24 e4 35 29 f5 25 
	IW1 := IB2  +  IW3;

.assert 22
END;


PROCEDURE AssertShortJump;
.j=1
BEGIN

.assert 50 03 00 80 fb 
	WHILE Cy DO INLINE(0);

.assert 50 06 30 d6 03 00 80 f8 
	WHILE Cy AND AC DO INLINE(0);

.assert 40 03 30 d6 03 00 80 f8 
	WHILE Cy OR AC DO INLINE(0);

.assert 22
END;


PROCEDURE AssertCase;
.j=1
BEGIN

.assert e5 20 14 60 0b 24 fd 60 07 04 60 04 24 fb 70 03 00 80 0f 24 fe 24 f5 50 05 14 24 fd 40 03 00 80 01 00 
	CASE IB1 OF
	1,4,3,8: 
		INLINE(0);
	10..20,22..24:
		INLINE(0);
	ELSE
		INLINE(0);
	END

.assert 22
END;

PROCEDURE AssertIf;
.j=1
BEGIN
.assert 50 03 00 80 01 00 
	IF Cy THEN INLINE(0) ELSE INLINE(0);

.assert 22
END;


PROCEDURE AssertCompare;
.j=1
BEGIN
.assert c3 e5 20 95 21 50 01 00 
	IF IB1 <  IB2 THEN INLINE(0);

.assert c3 e5 20 95 21 40 01 00 
	IF IB1 >= IB2 THEN INLINE(0);

.assert c3 e5 21 95 20 50 01 00 
	IF IB1 >  IB2 THEN INLINE(0);

.assert c3 e5 21 95 20 40 01 00 
	IF IB1 <= IB2 THEN INLINE(0);

.assert e5 20 65 21 70 01 00 
	IF IB1 =  IB2 THEN INLINE(0);

.assert e5 20 65 21 60 01 00 
	IF IB1 <> IB2 THEN INLINE(0);

.assert c3 e5 24 95 26 e5 25 95 27 50 01 00 
	IF IW1 <  IW2 THEN INLINE(0);

.assert c3 e5 24 95 26 e5 25 95 27 40 01 00 
	IF IW1 >= IW2 THEN INLINE(0);

.assert c3 e5 26 95 24 e5 27 95 25 50 01 00 
	IF IW1 >  IW2 THEN INLINE(0);

.assert c3 e5 26 95 24 e5 27 95 25 40 01 00 
	IF IW1 <= IW2 THEN INLINE(0);

.assert e5 24 65 26 70 04 e5 25 65 27 70 01 00 
	IF IW1 =  IW2 THEN INLINE(0);

.assert e5 24 65 26 70 04 e5 25 65 27 60 01 00 
	IF IW1 <> IW2 THEN INLINE(0);

.assert 22
END;


PROCEDURE AssertCompare2;
.j=1
BEGIN

.assert e5 20 85 21 f0 a4 fa ab f0 e5 24 25 26 c5 f0 e5 25 35 27 c5 f0 c3 9a c5 f0 9b 50 01 00 
	IF IW1+IW2 <  IB1*IB2 THEN INLINE(0);

	{
	IF IW1+IW2 >= IB1*IB2 THEN INLINE(0);
	IF IW1+IW2 >  IB1*IB2 THEN INLINE(0);
	IF IW1+IW2 <= IB1*IB2 THEN INLINE(0);
	IF IW1+IW2 =  IB1*IB2 THEN INLINE(0);
	IF IW1+IW2 <> IB1*IB2 THEN INLINE(0);
	}
END;


PROCEDURE AssertIndex;
.j=1
BEGIN

.assert 79 a2 c3 e5 24 97 f5 2a e5 25 09 97 f5 2b 
	IW4 := IW1 - UAW[1];

.assert 90 20 26 e0 fa a3 e0 fb 90 20 24 e0 2a fa a3 e0 3b fb 90 20 2a ea f0 a3 eb f0 
	XW4 := XW1 + XW2;

END;


PROCEDURE AssertExpressions;
.j=1
BEGIN

.assert e5 24 25 26 c5 f0 e5 25 35 27 c5 f0 25 28 f5 2a c5 f0 35 29 f5 2b 
	IW4 := IW1 + IW2 + IW3;

.assert e5 22 85 23 f0 a4 fa ab f0 e5 20 85 21 f0 a4 2a f5 2a c5 f0 3b f5 2b 
	IW4 := IB1*IB2 + IB3*IB4;

.assert c3 e5 22 95 23 fa e5 20 25 21 8a f0 a4 f5 2a 85 f0 2b 
	IW4 := (IB1+IB2) * (IB3-IB4);

.assert e5 20 85 21 f0 a4 fa ab f0 79 a2 e7 2a fa 09 e7 3b fb e5 20 85 21 f0 84 2a fa e4 3b fb e5 20 85 21 f0 84 c5 f0 2a c5 f0 e4 3b c5 f0 24 01 f5 2a c5 f0 34 00 f5 2b 
	IW4 := UAW[1] + IB1 * IB2 + IB1 DIV IB2 + IB1 MOD IB2 +1;

.assert 90 20 23 e0 25 23 fa 90 20 22 e0 55 22 8a f0 a4 fa ab f0 90 20 21 e0 65 21 fc 90 20 20 e0 45 20 8c f0 a4 c3 9a f5 2a c5 f0 9b f5 2b 
	IW4 := (IB1 OR XB1) * (IB2 XOR XB2) - (IB3 AND XB3) * (IB4 + XB4);

.assert 90 20 23 e0 25 23 fa 90 20 22 e0 55 22 8a f0 a4 fa 90 20 21 e0 65 21 fb 90 20 20 e0 45 20 8b f0 a4 c3 9a f5 20 
	IB1 := (IB1 OR XB1) * (IB2 XOR XB2) - (IB3 AND XB3) * (IB4 + XB4);

.assert e5 20 85 21 f0 84 aa f0 e5 20 85 21 f0 84 85 21 f0 a4 2a f5 23 
	IB4 := (IB1 DIV IB2) * IB2 + IB1 MOD IB2;

.assert e5 20 85 21 f0 a4 85 22 f0 a4 85 23 f0 a4 f5 23 
	IB4 := IB1 * IB2 * IB3 * IB4;

.assert e5 22 85 23 f0 84 aa f0 e5 20 85 21 f0 84 c5 f0 8a f0 84 f5 23 
	IB4 := (IB1 MOD IB2) DIV (IB3 MOD IB4);

.assert e5 21 c3 33 c5 f0 e4 33 c5 f0 24 00 f5 82 c5 f0 34 20 f5 83 e0 fa a3 e0 fb 90 20 04 e0 2a c5 f0 a3 e0 3b c5 f0 c3 33 c5 f0 33 c5 f0 24 00 f5 82 c5 f0 34 20 f5 83 e0 fa a3 e0 fb e5 21 c3 33 c5 f0 e4 33 c5 f0 24 00 f5 82 c5 f0 34 20 f5 83 e0 fc a3 e0 fd 90 20 04 e0 2c c5 f0 a3 e0 3d c5 f0 c3 33 c5 f0 33 c5 f0 24 00 f5 82 c5 f0 34 20 f5 83 e0 a3 c5 f0 e0 c5 f0 c3 9a fa c5 f0 9b fb e5 20 c3 33 c5 f0 e4 33 c5 f0 24 00 f5 82 c5 f0 34 20 f5 83 e0 fc a3 e0 fd 90 20 02 e0 2c c5 f0 a3 e0 3d c5 f0 c3 33 c5 f0 33 c5 f0 24 00 f5 82 c5 f0 34 20 f5 83 ea f0 a3 eb f0 
	XAW[XAW[1]+XAW[IB1]] := XAW[XAW[2]+XAW[IB2]] -  XAW[XAW[2]+XAW[IB2]];

.assert c3 e5 20 95 21 f5 2a e4 94 00 f5 2b 
	IW4 := IB1 - IB2;

.assert c3 e5 20 95 26 f5 2a e4 95 27 f5 2b 
	IW4 := IB1 - IW2;

.assert c3 e5 24 95 21 f5 2a e5 25 94 00 f5 2b 
	IW4 := IW1 - IB2;

.assert c3 e5 24 95 26 f5 2a e5 25 95 27 f5 2b 
	IW4 := IW1 - IW2;

.assert e5 20 55 21 f5 2a 75 2b 00 
	IW4 := IB1 AND IB2;

.assert e5 20 55 26 f5 2a 75 2b 00 
	IW4 := IB1 AND IW2;

.assert e5 24 55 21 f5 2a 75 2b 00 
	IW4 := IW1 AND IB2;

.assert e5 24 55 26 f5 2a e5 25 55 27 f5 2b 
	IW4 := IW1 AND IW2;

.assert e5 20 45 21 f5 2a 75 2b 00 
	IW4 := IB1 OR  IB2;

.assert e5 20 45 26 f5 2a e5 27 f5 2b 
	IW4 := IB1 OR  IW2;

.assert e5 24 45 21 f5 2a e5 25 f5 2b 
	IW4 := IW1 OR  IB2;

.assert e5 24 45 26 f5 2a e5 25 45 27 f5 2b 
	IW4 := IW1 OR  IW2;

.assert e5 20 65 21 f5 2a 75 2b 00 
	IW4 := IB1 XOR IB2;

.assert e5 20 65 26 f5 2a e5 27 f5 2b 
	IW4 := IB1 XOR IW2;

.assert e5 24 65 21 f5 2a e5 25 f5 2b 
	IW4 := IW1 XOR IB2;

.assert e5 24 65 26 f5 2a e5 25 65 27 f5 2b 
	IW4 := IW1 XOR IW2;

.assert e5 20 45 21 75 f0 00 65 28 f5 2a e5 29 f5 2b 
	IW4 := IB1 OR IB2 XOR IW3;

.assert e5 20 45 26 c5 f0 e5 27 c5 f0 65 28 f5 2a c5 f0 65 29 f5 2b 
	IW4 := IB1 OR IW2 XOR IW3;

.assert e5 20 55 26 75 f0 00 45 28 f5 2a e5 29 f5 2b 
	IW4 := IB1 AND IW2 OR IW3;
END;


{ AJUMP/LJUMP }
.assert 77ff 22 22 12 77 ff 11 00 22 
PROCEDURE P1; END;
PROCEDURE P2; END;
PROCEDURE P3; BEGIN P1; P2; END;

END.
