/****************************************************************)
(*								*)
(*								*)
(*	N       N        AAA       N       N      OOOOO		*)
(*	NN      N       A   A      NN      N     O     O	*)
(*	N N     N      A     A     N N     N    O       O	*)
(*	N  N    N     A       A    N  N    N    O       O	*)
(*	N   N   N     A       A    N   N   N    O       O	*)
(*	N    N  N     AAAAAAAAA    N    N  N    O       O	*)
(*	N     N N     A       A    N     N N    O       O	*)
(*	N      NN     A       A    N      NN     O     O	*)
(*	N       N     A       A    N       N      OOOOO		*)
(*								*)
(*								*)
(****************************************************************)
(*	Compiler fuer ein *sehr* eingeschraenktes Pascal.	*)
(*	Erzeugt Maschinencode fuer 8031 & co Prozessoren.	*)
(****************************************************************/

/*===================================================================*\
|*	$Id: hexfile.c,v 1.1 2018/12/21 00:14:50 wolf Exp $
|*=====================================================================
|*
|*	$Log: hexfile.c,v $
|*	Revision 1.1  2018/12/21 00:14:50  wolf
|*	Initial revision
|*
|*	Revision 1.1  2018/12/20 22:27:22  wolf
|*	Initial revision
|*
|*	Revision 1.1  2018/12/20 16:03:56  wolf
|*	Initial revision
|*
|*	Revision 1.3  2011/08/09 17:26:17  wolf
|*	* Cleanup
|*
|*	Revision 1.2  2008/12/12 20:22:21  wolf
|*	*** empty log message ***
|*
|*	Revision 1.1  2008/12/07 09:43:42  wolf
|*	Initial revision
|*
|*=====================================================================
|*	1988-1996 als Turbopascal-Programm für 8080 und 8086
\*===================================================================*/

#include "nano.h"
#include "hexfile.h"

#include <stdio.h>


FILE * hexfile;


#define MaxBytes (16)

static uint8 buffer[MaxBytes];

static unsigned bufaddr = 0;
static unsigned bufindex= 0;

static void
hexrecord (uint8 len, uint16 addr, uint8 type, const uint8 data[]) {
	uint8 check = 0;
	unsigned i;
	if (!hexfile) return;
	fprintf (hexfile, ":%02x%04x%02x", len, addr, type);
	check -= len;
	check -= ((addr>>8) & 0xff);
	check -= (addr & 0xff);
	check -= type;
	for (i=0; i<len; i++) {
		check -= data[i];
		fprintf (hexfile, "%02x", data[i]);
	}
	fprintf (hexfile, "%02x\n", check);
	fflush(hexfile);
}

static void
hexflush (void) {
	if (!bufindex) return;
	hexrecord (bufindex, bufaddr, 0, buffer);
	bufaddr+=bufindex;
	bufindex=0;
}

void
Out (unsigned addr, uint8 byte) {
	extern void AssertByte (unsigned addr, uint8 byte);
	AssertByte (addr, byte);
	if (addr != bufaddr+bufindex || bufindex>=MaxBytes) {
		hexflush();
		bufaddr=addr;
	}
	buffer[bufindex++] = byte;
}

void
CloseOut (unsigned addr) {
	hexflush ();
	hexrecord (0, addr, 1, NULL);
	fflush(hexfile);
}


/*===================================================================*\
|*	$Id: hexfile.c,v 1.1 2018/12/21 00:14:50 wolf Exp $
\*===================================================================*/
