/****************************************************************)
(*								*)
(*								*)
(*	N       N        AAA       N       N      OOOOO		*)
(*	NN      N       A   A      NN      N     O     O	*)
(*	N N     N      A     A     N N     N    O       O	*)
(*	N  N    N     A       A    N  N    N    O       O	*)
(*	N   N   N     A       A    N   N   N    O       O	*)
(*	N    N  N     AAAAAAAAA    N    N  N    O       O	*)
(*	N     N N     A       A    N     N N    O       O	*)
(*	N      NN     A       A    N      NN     O     O	*)
(*	N       N     A       A    N       N      OOOOO		*)
(*								*)
(*								*)
(****************************************************************)
(*	Compiler fuer ein *sehr* eingeschraenktes Pascal.	*)
(*	Erzeugt Maschinencode fuer 8031 & co Prozessoren.	*)
(****************************************************************/

/*=====================================================================
|*	$Id: nano.h,v 1.1 2018/12/21 00:15:19 wolf Exp $
|*=====================================================================
|*
|*	$Log: nano.h,v $
|*	Revision 1.1  2018/12/21 00:15:19  wolf
|*	Initial revision
|*
|*	Revision 1.1  2018/12/20 22:27:37  wolf
|*	Initial revision
|*
|*	Revision 1.1  2018/12/20 16:03:56  wolf
|*	Initial revision
|*
|*	Revision 1.7  2011/08/09 17:26:58  wolf
|*	* Cleanup
|*
|*	Revision 1.6  2010/12/24 16:26:09  wolf
|*	*** empty log message ***
|*
|*	Revision 1.5  2008/12/12 20:22:21  wolf
|*	*** empty log message ***
|*
|*	Revision 1.4  2008/12/07 09:43:42  wolf
|*	*** empty log message ***
|*
|*	Revision 1.3  2008/12/06 16:03:16  wolf
|*	*** empty log message ***
|*
|*=====================================================================
|*	1988-1996 als Turbopascal-Programm für 8080 und 8086
\*===================================================================*/

#ifndef __NANO_H__
#define __NANO_H__


#include "config.h"

#include <stdio.h>

/*------------------------------------------------------*\
|*	Fehlerbehandlung				*|
\*------------------------------------------------------*/

extern void
Warning (const char message[], const char* param);

extern void
Error (const char message[], const char* param);

extern void
Fatal (const char message[], const char* param);

extern const char MsgConstCondition[];
extern const char MsgConstOverflow[];
extern const char MsgError[];
extern const char MsgErrorAborted[];
extern const char MsgErrorDeleted[];
extern const char MsgExpectedConstant[];
extern const char MsgExpectedExpression[];
extern const char MsgExpectedStatement[];
extern const char MsgExpectedToken[];
extern const char MsgExpectedType[];
extern const char MsgExpectedTypename[];
extern const char MsgExpectedValue[];
extern const char MsgExpectedVariable[];
extern const char MsgFopen[];
extern const char MsgFread[];
extern const char MsgInternal[];
extern const char MsgInvalid[];
extern const char MsgLimit[];
extern const char MsgNameDefined[];
extern const char MsgNameUndefined[];
extern const char MsgPrepEOF[];
extern const char MsgPrepUnknown[];
extern const char MsgResource[];
extern const char MsgRestrictedMode[];
extern const char MsgRestriction[];
extern const char MsgScanString[];
extern const char MsgScanUnknown[];

/*------------------------------------------------------*\
|*	Programmoptionen				*|
\*------------------------------------------------------*/

static __inline unsigned
getOption (char opt) {
	extern unsigned Options[32];
	return Options[opt&0x1f];
}

static __inline BOOL
chkOption (char opt, char bit) {
	extern unsigned Options[32];
	return Options[opt&0x1f] & (1<<(bit&0x1f)) ? 1 : 0;
}

static __inline void
SetOption (char opt, unsigned value) {
	extern unsigned Options[32];
	Options[opt&0x1f] = value;
}

static __inline void
ClrOption (char opt) {
	extern unsigned Options[32];
	Options[opt&0x1f] = 0;
}


/*------------------------------------------------------*\
|*	Programmlisting					*|
\*------------------------------------------------------*/

extern FILE * lstfile;
extern FILE * errfile;
extern int restrictedMode;

void
lstfileselect (const char*);


#endif

/*===================================================================*\
|*	$Id: nano.h,v 1.1 2018/12/21 00:15:19 wolf Exp $
\*===================================================================*/
