/****************************************************************)
(*								*)
(*								*)
(*	N       N        AAA       N       N      OOOOO		*)
(*	NN      N       A   A      NN      N     O     O	*)
(*	N N     N      A     A     N N     N    O       O	*)
(*	N  N    N     A       A    N  N    N    O       O	*)
(*	N   N   N     A       A    N   N   N    O       O	*)
(*	N    N  N     AAAAAAAAA    N    N  N    O       O	*)
(*	N     N N     A       A    N     N N    O       O	*)
(*	N      NN     A       A    N      NN     O     O	*)
(*	N       N     A       A    N       N      OOOOO		*)
(*								*)
(*								*)
(****************************************************************)
(*	Compiler fuer ein *sehr* eingeschraenktes Pascal.	*)
(*	Erzeugt Maschinencode fuer 8031 & co Prozessoren.	*)
(****************************************************************/

/*===================================================================*\
|*	$Id: scanner.h,v 1.1 2018/12/21 00:15:19 wolf Exp $
|*===================================================================*|
|*
|*	$Log: scanner.h,v $
|*	Revision 1.1  2018/12/21 00:15:19  wolf
|*	Initial revision
|*
|*	Revision 1.1  2018/12/20 22:27:37  wolf
|*	Initial revision
|*
|*	Revision 1.1  2018/12/20 16:03:56  wolf
|*	Initial revision
|*
|*	Revision 1.14  2011/08/09 17:26:58  wolf
|*	* Cleanup
|*
|*	Revision 1.13  2008/12/12 20:22:21  wolf
|*	*** empty log message ***
|*
|*	Revision 1.12  2008/12/07 09:43:42  wolf
|*	*** empty log message ***
|*
|*===================================================================*|
|*	1988-1996 als Turbopascal-Programm für 8080 und 8086
\*===================================================================*/

#ifndef	__SCANNER_H__
#define	__SCANNER_H__

#include "config.h"


unsigned
getCurrentColumn (void);

char *
getTokenName (void);

uint16
getTokenValue (void);


/*--------------------------------------*\
|*					*|
|*	Enumeration der Token		*|
|*					*|
\*--------------------------------------*/

typedef enum {
	snul, seof,
	/*------------------------------*\
	|*	Konstanten		*|
	\*------------------------------*/
	snumber, stxt,
	/*------------------------------*\
	|*	Identifier		*|
	\*------------------------------*/
	sident,
	/*------------------------------*\
	|*	Typen / Deklarationen	*|
	\*------------------------------*/
	sbyte, sword, sstring,
	sintern, sextern,
	sarray, stable,
	svar, sconst,
	/*------------------------------*\
	|*	Befehle			*|
	\*------------------------------*/
	sprogram, sprocedure, sinterrupt, sreturn,
	sbegin, send,
	scase, sof,
	sfor, sto,
	sif, sthen, selse,
	sloop, sbreak, sexit, scontinue,
	squick,
	srepeat,
	sdo, suntil,
	swhile,
	/*------------------------------*\
	|*	Prozeduren		*|
	\*------------------------------*/
	slock, sinline,
	sincr, sdecr,
	sclr, sset, scpl,
	sshl, sshr,
	/*------------------------------*\
	|*	Keyword-Funktion	*|
	\*------------------------------*/
	saddr, slo, shi,
	/*------------------------------*\
	|*	Keyword-Operator	*|
	\*------------------------------*/
	sdiv, smod,
	/*------------------------------*\
	|*	Interpunktion		*|
	\*------------------------------*/
	sassign,
	sdot, scomma, scolon, ssemi,
	srka, srkz,
	seka, sekz,
	supto, scaret, sat,
	/*------------------------------*\
	|*	Operator		*|
	\*------------------------------*/
	sadd, saddc, ssub, ssubb,
	smul,
	seq, sne,
	sge, sgt, sle, slt,
	sin,
	sand, sor, sxor,
	sexclam, snot, stilde
} Token;


/*--------------------------------------*\
|*	Zeige das nächste Token		*|
\*--------------------------------------*/

Token
getToken (void);

/*--------------------------------------*\
|*	Verbrauche ein Token		*|
\*--------------------------------------*/

void
Cns (void);

void
Consume (Token t);


#endif

/*===================================================================*\
|*	$Id: scanner.h,v 1.1 2018/12/21 00:15:19 wolf Exp $
\*===================================================================*/
