/****************************************************************)
(*								*)
(*								*)
(*	N       N        AAA       N       N      OOOOO		*)
(*	NN      N       A   A      NN      N     O     O	*)
(*	N N     N      A     A     N N     N    O       O	*)
(*	N  N    N     A       A    N  N    N    O       O	*)
(*	N   N   N     A       A    N   N   N    O       O	*)
(*	N    N  N     AAAAAAAAA    N    N  N    O       O	*)
(*	N     N N     A       A    N     N N    O       O	*)
(*	N      NN     A       A    N      NN     O     O	*)
(*	N       N     A       A    N       N      OOOOO		*)
(*								*)
(*								*)
(****************************************************************)
(*	Compiler fuer ein *sehr* eingeschraenktes Pascal.	*)
(*	Erzeugt Maschinencode fuer 8031 & co Prozessoren.	*)
(****************************************************************/

/*===================================================================*\
|*	$Id: symboltable.h,v 1.1 2018/12/21 00:15:19 wolf Exp $
|*===================================================================*|
|*
|*	$Log: symboltable.h,v $
|*	Revision 1.1  2018/12/21 00:15:19  wolf
|*	Initial revision
|*
|*	Revision 1.1  2018/12/20 22:27:54  wolf
|*	Initial revision
|*
|*	Revision 1.1  2018/12/20 16:03:56  wolf
|*	Initial revision
|*
|*	Revision 1.14  2011/08/09 17:26:58  wolf
|*	* Cleanup
|*
|*	Revision 1.13  2008/12/07 09:43:42  wolf
|*	*** empty log message ***
|*
|*===================================================================*|
|*	1988-1996 als Turbopascal-Programm für 8080 und 8086
\*===================================================================*/

#ifndef	__SYMBOLTABLE_H__
#define	__SYMBOLTABLE_H__

#include "config.h"
#include "types.h"


typedef struct symboltableentry{
	const char *	id;
	Class		sclass;
	Storage		storage;
	Type		type;
	BOOL		absolute;
	BOOL		used;
	BOOL		indirect;
	uint16		address;
	uint16		size;
} SymbolTableEntry;


typedef SymbolTableEntry*	Symbol;


Symbol
CreateSymbol (Class newclass, const char name[]);

Symbol
FindSymbol (const char name[]);

void
ReleaseScope (Symbol sym, unsigned npara);

void 
ShowScope (Symbol scope, FILE* file);

void
AllocateMemory (Symbol sym);


#endif

/*===================================================================*\
|*	$Id: symboltable.h,v 1.1 2018/12/21 00:15:19 wolf Exp $
\*===================================================================*/
