/****************************************************************)
(*								*)
(*								*)
(*	N       N        AAA       N       N      OOOOO		*)
(*	NN      N       A   A      NN      N     O     O	*)
(*	N N     N      A     A     N N     N    O       O	*)
(*	N  N    N     A       A    N  N    N    O       O	*)
(*	N   N   N     A       A    N   N   N    O       O	*)
(*	N    N  N     AAAAAAAAA    N    N  N    O       O	*)
(*	N     N N     A       A    N     N N    O       O	*)
(*	N      NN     A       A    N      NN     O     O	*)
(*	N       N     A       A    N       N      OOOOO		*)
(*								*)
(*								*)
(****************************************************************)
(*	Compiler fuer ein *sehr* eingeschraenktes Pascal.	*)
(*	Erzeugt Maschinencode fuer 8031 & co Prozessoren.	*)
(****************************************************************/

/*===================================================================*\
|*	$Id: types.h,v 1.1 2018/12/21 00:15:19 wolf Exp $
|*===================================================================*|
|*
|*	$Log: types.h,v $
|*	Revision 1.1  2018/12/21 00:15:19  wolf
|*	Initial revision
|*
|*	Revision 1.1  2018/12/20 22:27:54  wolf
|*	Initial revision
|*
|*	Revision 1.1  2018/12/20 16:03:56  wolf
|*	Initial revision
|*
|*	Revision 1.8  2011/08/09 17:26:58  wolf
|*	* Cleanup
|*
|*	Revision 1.7  2008/12/12 20:22:21  wolf
|*	*** empty log message ***
|*
|*	Revision 1.6  2008/12/07 09:43:42  wolf
|*	*** empty log message ***
|*
|*===================================================================*|
|*	1988-1996 als Turbopascal-Programm für 8080 und 8086
\*===================================================================*/

#ifndef	__TYPES_H__
#define	__TYPES_H__

#include "config.h"


typedef enum {
	parameter, noclass, variable, bitvariable, constant
} Class;


typedef enum {
	notype, byte, word, string, proc, bit
} Type;

uint16
typesize (Type t);


typedef enum {
	non, code, external, internal, reg, upb
} Storage;

uint16
address_size (Storage s);


const char * ClassName	(Class);
const char * TypeName	(Type);
const char * StorageName(Storage);

void 
VerifyType (Type found, Type expected);


#endif

/*===================================================================*\
|*	$Id: types.h,v 1.1 2018/12/21 00:15:19 wolf Exp $
\*===================================================================*/
